// Combines the data from multiple parsing trees into one object.
// data: an array containing data from different parsers, generated by the async library. Each item in the array is an object containing the output of a single parser.
module.exports = function(tree) {
  var newTree = [];

  for (var i in tree) {
    var obj = {
      title: tree[i].title,
      description: tree[i].description,
      docs: tree[i].docs,
      fileName: tree[i].fileName
    }

    for (var j in this.options.adapters) {
      var lib = this.options.adapters[j];
      if (tree[i][lib]) {
        obj[lib] = this.adapters[lib].process(tree[i][lib]);
      }
    }

    newTree.push(obj);
  }

  return newTree;
}